package com.eftpay.payplugin.eft_payplugin;

import android.Manifest;
import android.content.pm.PackageManager;
import android.os.Build;
import android.util.Log;

import com.eftpay.payplugin.eft_payplugin.alipay.PayResponse;
import com.eftpay.payplugin.eft_payplugin.wechat.Constants;
import com.eftpay.payplugin.eft_payplugin.wechat.WechatServer;

import java.util.HashMap;
import java.util.Map;

import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry;
import io.flutter.plugin.common.PluginRegistry.Registrar;

/** EftPaypluginPlugin */
public class EftPaypluginPlugin implements MethodCallHandler, PluginRegistry.RequestPermissionsResultListener {
  public static Registrar registrar;
  public static final int REQUEST_READ_PHONE_STATE = 1001;
  public Result result;
  /** Plugin registration. */
  public static void registerWith(Registrar registrar) {
    EftPaypluginPlugin.registrar = registrar;
    final MethodChannel channel = new MethodChannel(registrar.messenger(), "eft_payplugin");
    EftPaypluginPlugin payPlugin = new EftPaypluginPlugin();
    channel.setMethodCallHandler(payPlugin);
    registrar.addRequestPermissionsResultListener(payPlugin);
  }

  @Override
  public void onMethodCall(final MethodCall call,final Result result) {
    EftPaypluginPlugin.this.result = result;
    if (call.method.equals("getPlatformVersion")) {
      result.success("Android " + android.os.Build.VERSION.RELEASE);
    }else if(call.method.equals("request_deviceid_permission")){
      if(Build.VERSION.SDK_INT>=23){
        int permissionCheck = ContextCompat.checkSelfPermission(registrar.activity(), Manifest.permission.READ_PHONE_STATE);

        if (permissionCheck != PackageManager.PERMISSION_GRANTED) {
          ActivityCompat.requestPermissions(registrar.activity(), new String[]{Manifest.permission.READ_PHONE_STATE}, REQUEST_READ_PHONE_STATE);

        } else {
          result.success("00");
        }
      }else {
        result.success("00");
      }

    }else if(call.method.equals("regiest")){
      //微信注册
      Constants.APP_ID = call.argument("appid");
      int r = WechatServer.regiest(registrar.context());
      result.success(r>0?"00":"01");
    }else if (call.method.equals("pay")) {

      final Map map = new HashMap();
      map.putAll((Map) call.arguments);
      Log.e("argments", String.valueOf(map));

      new Thread(new Runnable() {
        @Override
        public void run() {

          final PayResponse payResponse = NetWorkServer2.getPayInfo(EftPaypluginPlugin.registrar.activity(),
                  map);

          EftPaypluginPlugin.registrar.activity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
              if(payResponse!=null){
                result.success(payResponse.getMap());
              }
            }
          });
        }
      }).start();


    }else if (call.method.equals("query")) {

      final Map map = new HashMap();
      map.putAll((Map) call.arguments);
      Log.e("argments", String.valueOf(map));

      new Thread(new Runnable() {
        @Override
        public void run() {

          final PayResponse payResponse = NetWorkServer2.query(map
                  );

          EftPaypluginPlugin.registrar.activity().runOnUiThread(new Runnable() {
            @Override
            public void run() {
              if(payResponse!=null){
                result.success(payResponse.getQueryResult());
              }
            }
          });
        }
      }).start();


    } else {
      result.notImplemented();
    }
  }

  @Override
  public boolean onRequestPermissionsResult(int requestCode, String[] permissions, int[] grantResults) {

    switch (requestCode) {
      case REQUEST_READ_PHONE_STATE:
        if ((grantResults.length > 0) && (grantResults[0] == PackageManager.PERMISSION_GRANTED)) {
          result.success("00");
        }else {
          result.success("01");
        }
        break;

      default:
        break;
    }
    return false;
  }
}
