package com.eftpay.payplugin.eft_payplugin;

import android.app.Activity;
import android.content.Context;
import android.util.Log;

import com.alipay.sdk.app.PayTask;
import com.eftpay.payplugin.eft_payplugin.alipay.PayResponse;
import com.eftpay.payplugin.eft_payplugin.utils.SharedPreferenceUtil;
import com.eftpay.payplugin.eft_payplugin.utils.SignUtil;
import com.eftpay.payplugin.eft_payplugin.utils.TimeUtil;
import com.eftpay.payplugin.eft_payplugin.wechat.WechatServer;
import com.tencent.mm.opensdk.modelpay.PayReq;

import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Map;


public class NetWorkServer2 {


	public static HttpURLConnection getConnection(String host,String params)throws Exception{
		URL url = new URL(host);
		HttpURLConnection connection = (HttpURLConnection) url.openConnection();
		connection.setRequestProperty("Accept-Charset", "UTF-8");
		connection.setRequestProperty("connection", "keep-Alive");
		connection.setRequestMethod("POST");
		connection.setDoOutput(true);
		connection.setDoInput(true);
		connection.setUseCaches(false);
		connection.setRequestProperty("Content-Type", "application/json");
		connection.connect();

		BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(connection.getOutputStream(), "UTF-8"));
		bw.write(params);
		bw.flush();
		bw.close();
		return connection;
	}
	public static String getSubject(Context context){
		SharedPreferenceUtil sp_ref_num = new SharedPreferenceUtil(context, "###ref_num");
		int ref_num =  sp_ref_num.getInt("num");
		ref_num++;
		if(ref_num==10000){
			ref_num=1;
		}
		sp_ref_num.saveInt("num", ref_num);
		Log.d("ref_num", ""+ref_num);
		return TimeUtil.getNowTime()+""+ String.format("%06d", ref_num);

	}

	public static String is2String(InputStream is)throws Exception{

		//连接后，创建一个输入流来读取response
		BufferedReader bufferedReader = new BufferedReader(new
				InputStreamReader(is,"utf-8"));
		String line = "";
		StringBuilder stringBuilder = new StringBuilder();
		//每次读取一行，若非空则添加至 stringBuilder
		while((line = bufferedReader.readLine()) != null){
			stringBuilder.append(line);
		}
		//读取所有的数据后，赋值给 response
		String response = stringBuilder.toString().trim();
		return response;


	}

//	static ResponseInfo<String> responseInfo;
	public static PayResponse getPayInfo(final Activity context, final Map<String,String> requestMap){


		SignUtil.secret_key = ""+requestMap.get("secret_key");
		String wallet = ""+requestMap.get("wallet");

		String time = TimeUtil.getNowTime();

		final JSONObject map = new JSONObject();
		try {
			map.put("buyerType", "android");
			map.put("pay_scene", "APP"); //APP/JSAPI/NATIVE
			map.put("time", time);
			for(String key : requestMap.keySet()){
				if(!"secret_key".equals(key)&&!"host".equals(key)){
					map.put(key,requestMap.get(key));
				}
			}


			map.put("sign", SignUtil.getSign(map));
			
			Log.d("request json", map.toString());
			

		} catch (Exception e) {
			e.printStackTrace();
			return  new PayResponse("-2","参数异常");//参数异常
		}
		final String params = map.toString();

		try {
			HttpURLConnection connection = getConnection(requestMap.get("host"),params);

			int responseCode = connection.getResponseCode();
			if(responseCode == HttpURLConnection.HTTP_OK){
				InputStream inputStream = connection.getInputStream();
				String result = is2String(inputStream);//将流转换为字符串。
				Log.d("getPayInfo","result============="+result);


				if(result==null){
					Log.e("getPayInfo", "result is null");
					return new PayResponse("-3","结果为空");
				}
				Log.d("result", ""+result);


				try {
					JSONObject jsonObject = new JSONObject(result);


					if(!"00".equals(jsonObject.getString("return_status"))){
						return new PayResponse(jsonObject.getString("return_status"),jsonObject.toString());
					}

					if("ALIPAYCN".equals(wallet)||"ALIPAYHK".equals(wallet)){
						boolean isSign = SignUtil.isSign(jsonObject);
						if(!isSign){
//							Toast.makeText(context,"验签错误！", Toast.LENGTH_LONG).show();
							return new PayResponse("-10",jsonObject.toString()); //签名错误
						}
					}else if("WECHATCN".equals(wallet)){
						boolean isSign = SignUtil.isSign2(jsonObject,result);
						if(!isSign){
//							Toast.makeText(context,"验签错误！", Toast.LENGTH_LONG).show();
							return new PayResponse("-10",jsonObject.toString()); //签名错误
						}
					}


				} catch (JSONException e) {
					e.printStackTrace();
				}

				if("ALIPAYCN".equals(wallet)||"ALIPAYHK".equals(wallet)){
					return pay(context,result);
				}else if("WECHATCN".equals(wallet)){
					/*
				{
					"package": "Sign=WXPay",
						"appid": "wx9a52ebdae52f710f",
						"sign": "FEE6B6CA2CB8A003C7A4BFD5942B5D57",
						"partnerid": "3900000021",
						"prepayid": "wx031008287183881bb0d88d903800543448",
						"noncestr": "f66220c71bd482b6b06190a7a5fbd263",
						"timestamp": "1525313152"
				}
				*/
                    try {
                        wechatResultJson = new JSONObject(result);
                        JSONObject jsonObject = wechatResultJson.getJSONObject("pay_apptrade");
//						JSONObject jsonObject = new JSONObject(responseInfo.result);
                        final PayReq request = new PayReq();
                        request.appId = jsonObject.getString("appid");
                        request.partnerId =jsonObject.getString("partnerid");
                        request.prepayId = jsonObject.getString("prepayid");
                        request.packageValue =jsonObject.getString("package");
                        request.nonceStr = jsonObject.getString("noncestr");
                        request.timeStamp = jsonObject.getString("timestamp");
                        request.sign = jsonObject.getString("sign");


                        return WechatServer.weChatPay(context,request);

                    } catch (Exception e) {
                        e.printStackTrace();
                    }

                }else{
					return  new PayResponse("-2","参数异常");//参数异常
				}


			}else {
				return new PayResponse("-4","网络错误");//未知异常
			}



		} catch (Exception e) {
			e.printStackTrace();
		}
		return new PayResponse("-1","未知异常");//未知异常

		
	}

	public static JSONObject alipayResultJson;
    public static JSONObject wechatResultJson;
//	public static boolean canRefuld = false;


	
	public static PayResponse pay(final Activity context, final String orderInfo){

		try {
			// 构造PayTask 对象
			PayTask alipay = new PayTask(context);
			// 调用支付接口，获取支付结果

//					String order = buildOrderParam(new JSONObject(responseInfo.result).getJSONObject("pay_apptrade"));
			alipayResultJson = new JSONObject(orderInfo);
			String order = alipayResultJson.getString("pay_apptrade");
			Log.d("order", order);


			String result = alipay.pay(order, true);


			final PayResponse response = new PayResponse(result);

//					9000	订单支付成功
//					8000	正在处理中，支付结果未知（有可能已经支付成功），请查询商户订单列表中订单的支付状态 .(支付宝服务端返回的错误码)
//					4000	订单支付失败
//					6001	用户中途取消
//					6002	网络连接出错
//					6004	支付结果未知（有可能已经支付成功），请查询商户订单列表中订单的支付状态 。（支付宝客户端不能得到服务端的响应，往往是因为网络原因）
//					其它	其它支付错误


//			final String resultStatus = response.getResultStatus();
//			// 判断resultStatus 为“9000”则代表支付成功，具体状态码代表含义可参考接口文档
//			context.runOnUiThread(new Runnable() {
//
//				@Override
//				public void run() {
//					if (TextUtils.equals(resultStatus, "9000")) {
//						Toast.makeText(context, "支付成功", Toast.LENGTH_LONG).show();
//						canRefuld = true;
//					}else{
//						Toast.makeText(context, "支付失败", Toast.LENGTH_LONG).show();
//					}
//				}
//			});

			return response;

		} catch (Exception e) {
			e.printStackTrace();
		}
		return new PayResponse("-1","未知异常");//未知异常
	}
	public static PayResponse query(String wallet,String url,String userKey,String signKey,String outTradeNo){
		SignUtil.secret_key = ""+signKey;
		String payTypeStr = "";
		if(wallet!=null){
			if(wallet.contains("ALIPAY")){
				payTypeStr = "Alipay";
			}else if(wallet.contains("WECHAT")){
				payTypeStr = "WeChat";
			}
		}

		String time = TimeUtil.getNowTime();
		final JSONObject map = new JSONObject();
		try {
			map.put("querytype","OUT_TRADE");
			map.put("out_trade_no",outTradeNo);
			map.put("user_confirm_key",userKey);
			map.put("paytype",payTypeStr);
			map.put("buyertype", "android");
			map.put("time", time);
			map.put("payment_type",wallet);

			map.put("sign", SignUtil.getSign(map));

			Log.d("request json", map.toString());


		} catch (Exception e) {
			e.printStackTrace();
			return  new PayResponse("-2","参数异常");//参数异常
		}
		final String params = map.toString();

		try {
			HttpURLConnection connection = getConnection(url,params);

			int responseCode = connection.getResponseCode();
			if(responseCode == HttpURLConnection.HTTP_OK){
				InputStream inputStream = connection.getInputStream();
				String result = is2String(inputStream);//将流转换为字符串。
				Log.d("getPayInfo","result============="+result);


				if(result==null){
					Log.e("getPayInfo", "result is null");
					return new PayResponse("-3","结果为空");
				}
				Log.d("result", ""+result);


				try {
					JSONObject jsonObject = new JSONObject(result);


					if(!"00".equals(jsonObject.getString("return_status"))){
						return new PayResponse(jsonObject);
					}
					boolean isSign = SignUtil.isSign(jsonObject);
					if(!isSign){
						return new PayResponse("-10",jsonObject.toString()); //签名错误
					}
					return new PayResponse(jsonObject);


				} catch (JSONException e) {
					e.printStackTrace();
				}

			}else {
				return new PayResponse("-4","网络错误");//未知异常
			}



		} catch (Exception e) {
			e.printStackTrace();
		}
		return new PayResponse("-1","未知异常");//未知异常
	}

	public static PayResponse query(final Map<String,String> requestMap){
		SignUtil.secret_key = ""+requestMap.get("secret_key");
		String time = TimeUtil.getNowTime();
		final JSONObject map = new JSONObject();
		try {
			map.put("querytype","OUT_TRADE");
			map.put("buyertype", "android");
			map.put("time", time);
			for(String key : requestMap.keySet()){
				if(!"secret_key".equals(key)&&!"host".equals(key)){
					map.put(key,requestMap.get(key));
				}
			}

			map.put("sign", SignUtil.getSign(map));

			Log.d("request json", map.toString());


		} catch (Exception e) {
			e.printStackTrace();
			return  new PayResponse("-2","参数异常");//参数异常
		}
		final String params = map.toString();

		try {
			HttpURLConnection connection = getConnection(requestMap.get("host"),params);

			int responseCode = connection.getResponseCode();
			if(responseCode == HttpURLConnection.HTTP_OK){
				InputStream inputStream = connection.getInputStream();
				String result = is2String(inputStream);//将流转换为字符串。
				Log.d("getPayInfo","result============="+result);


				if(result==null){
					Log.e("getPayInfo", "result is null");
					return new PayResponse("-3","结果为空");
				}
				Log.d("result", ""+result);


				try {
					JSONObject jsonObject = new JSONObject(result);


					if(!"00".equals(jsonObject.getString("return_status"))){
						return new PayResponse(jsonObject);
					}
					boolean isSign = SignUtil.isSign(jsonObject);
					if(!isSign){
						return new PayResponse("-10",jsonObject.toString()); //签名错误
					}
					return new PayResponse(jsonObject);


				} catch (JSONException e) {
					e.printStackTrace();
				}

			}else {
				return new PayResponse("-4","网络错误");//未知异常
			}



		} catch (Exception e) {
			e.printStackTrace();
		}
		return new PayResponse("-1","未知异常");//未知异常
	}
}
