//
//  NSDate+GetTime.m
//
//  Created by sky on 2018/5/13.
//  Copyright © 2018年 Eftsolution. All rights reserved.
//


#import "NSDate+GetTime.h"


@implementation NSDate (GetTime)

#pragma mark- 比较日期,是否在n小时之前
+ (BOOL)compareHoursBefore:(NSInteger)hours with:(NSString *)dateString {
  NSDate *date = [NSDate getDateOfTimeString:dateString withFormatterString:timeToSeconds];
  NSTimeInterval seconds = [[NSDate date] timeIntervalSinceDate:date];
  NSLog(@"相差秒数 = %.2f",seconds);
  if (seconds>hours*60*60) {
    return YES;
  }
  return NO;
}


+ (BOOL)isTimeCorrect:(NSString*) time {
  NSDate *date = [NSDate getDateOfTimeString:time withFormatterString:@"yyyyMMddHHmmss"];
  NSTimeInterval seconds = [[NSDate date] timeIntervalSinceDate:date];
  NSLog(@"相差秒数 = %.2f",seconds);
  if(seconds<6*60*60&&seconds>-6*60*60){
    return YES;
  }
  return NO;
}

+(BOOL) isTimeCorrectWithGMTTime:(NSString*)gmtTime pushTime:(NSString*)pushTime{
  NSDate *gmtDate = [NSDate getDateOfTimeString:gmtTime withFormatterString:@"yyyyMMddHHmmss"];
  NSDate *pushDate = [NSDate getDateOfTimeString:pushTime withFormatterString:@"yyyyMMddHHmmss"];
  NSTimeInterval seconds = [gmtDate timeIntervalSinceDate:pushDate];
  NSLog(@"相差秒数 = %.2f",seconds);
  if(seconds<12*60*60&&seconds>-12*60*60){
    return YES;
  }
  return NO;
}


#pragma mark- 获取前后的时间
+ (NSDate *)getDateStringBeforeDay:(NSInteger)dayBefore {
  NSDateFormatter  *formatter = [[NSDateFormatter alloc]init];
  formatter.dateFormat = timeToDay;
  NSDate *date = [NSDate date];
  
  NSCalendar *cal = [NSCalendar currentCalendar];
  NSDateComponents *components = [cal components:NSCalendarUnitWeekday | NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay  fromDate:date];
  
  components.day -= dayBefore;
  
  NSDate *newDate = [cal dateFromComponents:components];
  return newDate;
}
//+ (NSDate *)getDateStringBeforeMinute:(NSInteger)minuteBefore {
//  NSDateFormatter  *formatter = [[NSDateFormatter alloc]init];
//  formatter.dateFormat = timeToSeconds;
//  NSDate *date = [NSDate date];
//  
//  NSCalendar *cal = [NSCalendar currentCalendar];
//  NSDateComponents *components = [cal components:NSCalendarUnitWeekday | NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay | NSCalendarUnitHour | NSCalendarUnitMinute | NSCalendarUnitSecond  fromDate:date];
//  
//  components.minute -= minuteBefore;
//  
//  NSDate *newDate = [cal dateFromComponents:components];
//  return newDate;
//}


#pragma mark- string->date
+ (NSDate *)getDateOfTimeString:(NSString *)time withFormatterString:(NSString *)formatterString {
  NSDateFormatter *dateFormatter = [[NSDateFormatter alloc]init];
  dateFormatter.dateFormat = formatterString;
  NSDate *date = [dateFormatter dateFromString:time];
  return date;
}
#pragma mark- 获取某个格式的现在时间
+ (NSString *)getDateStringOfFormat:(NSString *)format {
  NSDate *date = [NSDate date];
  NSDateFormatter *formatter = [[NSDateFormatter alloc]init];
  formatter.dateFormat = format;
  NSString *time = [formatter stringFromDate:date];
  return time;
}
#pragma mark- date->string
- (NSString *)getTimeStringOfFormat:(NSString *)format {
  NSDateFormatter *formatter = [[NSDateFormatter alloc]init];
  formatter.dateFormat = format;
  NSString *time = [formatter stringFromDate:self];
  return time;
}
#pragma string -> string
+ (NSString *)getTimeStringChangeWithOld:(NSString *)old withOldFormat:(NSString *)oldFormat withNewFormat:(NSString *)newFormat {
  NSDate *date = [self getDateOfTimeString:old withFormatterString:oldFormat];
  return [date getTimeStringOfFormat:newFormat];
}


//day 固定格式 yyyy-MM-dd
+ (NSString *)get01Time:(NSString*)day{
  NSLog(@"get01Time day=%@",day);
  NSString* str = [day stringByAppendingString:@" 00:00:00"];
  
  NSDateFormatter *dateFormatter = [[NSDateFormatter alloc]init];
  dateFormatter.dateFormat = @"yyyy-MM-dd HH:mm:ss";
  NSDate *date = [dateFormatter dateFromString:str];
  
  
  NSDateFormatter *formatter = [[NSDateFormatter alloc]init];
  formatter.dateFormat = @"yyyyMMddHHmmss";
  NSString* result = [formatter stringFromDate:date];
  
  
  NSLog(@"get01Time result=%@",result);
  return result;
}

//day 固定格式 yyyy-MM
+ (NSString *)get01Month:(NSString*)day{
  NSLog(@"get01Time day=%@",day);
  NSDateFormatter *dateFormatter = [[NSDateFormatter alloc]init];
  dateFormatter.dateFormat = @"yyyy-MM";
  NSDate *date = [dateFormatter dateFromString:day];
  
  
  NSDateFormatter *formatter = [[NSDateFormatter alloc]init];
  formatter.dateFormat = @"yyyyMM";
  NSString* result = [formatter stringFromDate:date];
  
  
  NSLog(@"get01Time result=%@",result);
  return result;
}


//day 固定格式 yyyy-MM-dd
+ (NSString *)get02Time:(NSString*)day{
  NSLog(@"get02Time day=%@",day);
  NSString* str = [day stringByAppendingString:@" 00:00:00"];
  
  NSDateFormatter *dateFormatter = [[NSDateFormatter alloc]init];
  dateFormatter.dateFormat = @"yyyy-MM-dd HH:mm:ss";
  NSDate *date = [dateFormatter dateFromString:str];
  
  NSCalendar* cal = [NSCalendar currentCalendar];
  NSDateComponents* components = [cal components:NSCalendarUnitWeekday | NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay  fromDate:date];
  components.day +=1;
  
  NSDate* newDate = [cal dateFromComponents:components];
  
  NSDateFormatter *formatter = [[NSDateFormatter alloc]init];
  formatter.dateFormat = @"yyyyMMddHHmmss";
  NSString* result = [formatter stringFromDate:newDate];
  
  
  NSLog(@"get02Time result=%@",result);
  return result;
}



+ (NSString *)getNowTime{
  NSDate *date = [NSDate date];
  NSDateFormatter *formatter = [[NSDateFormatter alloc]init];
  formatter.dateFormat = @"yyyyMMddHHmmss";
  NSString *time = [formatter stringFromDate:date];
  return time;
}
+ (NSString *)getTime15minuteBefore{
  NSDate *date = [NSDate date];
  
  NSCalendar* cal = [NSCalendar currentCalendar];
  NSDateComponents* components = [cal components:NSCalendarUnitWeekday | NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay  fromDate:date];
  components.minute -=15;
  
  NSDate* newDate = [cal dateFromComponents:components];
  
  NSDateFormatter *formatter = [[NSDateFormatter alloc]init];
  formatter.dateFormat = @"yyyyMMddHHmmss";
  NSString* result = [formatter stringFromDate:newDate];
  NSLog(@"get02Time result=%@",result);
  return result;
}


+ (NSString *)getLastMonthDay{
  
  
  NSDate *date = [NSDate date];
  
  NSCalendar* cal = [NSCalendar currentCalendar];
  NSDateComponents* components = [cal components:NSCalendarUnitWeekday | NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay  fromDate:date];
  components.month -=1;
  
  NSDate* newDate = [cal dateFromComponents:components];
  
  NSDateFormatter *formatter = [[NSDateFormatter alloc]init];
  formatter.dateFormat = @"yyyyMMdd";
  NSString* result = [formatter stringFromDate:newDate];
  
  
  NSLog(@"getLastMonthDay result=%@",result);
  return result;
}



@end
