//
//  PayUtil.m
//  ltxgtpay
//
//  Created by eft user on 2019/3/7.
//  Copyright © 2019年 Eftsolution. All rights reserved.
//

#import "PayUtil.h"
#import "NetWorkServer.h"
#import "NSDictionary+GetString.h"
@implementation PayUtil

+ (void)pay:(NSMutableDictionary*)dic finish:(void(^_Nullable)(BOOL isError,BOOL isSign,NSDictionary* _Nullable dic))finish{

  NSString* wallet = [dic objectForKey:@"wallet"];
  [dic setValue:@"ios" forKey:@"buyerType"];
  [dic setValue:@"APP" forKey:@"pay_scene"];
  [dic setValue:[NSDate getDateStringOfFormat:timeForRequest] forKey:@"time"];
  NSString* secret_key = [dic objectForKey:@"secret_key"];
  [dic removeObjectForKey:@"secret_key"];
  NSString* host = [dic objectForKey:@"host"];
  [dic removeObjectForKey:@"host"];
  
  NSString* sign = [[dic getSign:secret_key] SHA256];
  [dic setValue:sign forKey:@"sign"];
  
  [NetWorkServer postWithURL:host params:dic callBack:^(NSError* error, NSString*  data){
    BOOL isError = YES;
    BOOL isSign = NO;
    NSDictionary* resultDic = [NSJSONSerialization getJsonDictionaryWith:data];
    if(resultDic){
      if([@"00" isEqualToString:[resultDic objectForKey:@"return_status"]]){
        isError = NO;
        if(wallet&&[wallet containsString:@"WECHAT"]){
          isSign = [resultDic isSign:secret_key str:data];
        }else{
          isSign = [resultDic isSign:secret_key];
        }
      }
    }
    if(finish){
      finish(isError,isSign,resultDic);
    }
  }];
  
}


+ (void)pay:(int)payType url:(NSString*)url userKey:(NSString*)userKey signKey:(NSString*)signKey outTradeNo:(NSString*)outTradeNo price:(double)price currency:(NSString*)currency subject:(NSString*)subject body:(NSString*)body finish:(void(^_Nullable)(BOOL isError,BOOL isSign,NSDictionary* _Nullable dic))finish{
  switch (payType) {
    case ALIPAYCN:
      [PayUtil payAlipayCN:url userKey:userKey signKey:signKey outTradeNo:outTradeNo price:price currency:currency subject:subject body:body finish:finish];
      break;
    case ALIPAYHK:
      [PayUtil payAlipayHK:url userKey:userKey signKey:signKey outTradeNo:outTradeNo price:price currency:currency subject:subject body:body finish:finish];
      break;
    case WECHATCN:
      [PayUtil payWechatCN:url userKey:userKey signKey:signKey outTradeNo:outTradeNo price:price currency:currency subject:subject body:body finish:finish];
      break;
    case WECHATHK:
      [PayUtil payWechatHK:url userKey:userKey signKey:signKey outTradeNo:outTradeNo price:price currency:currency subject:subject body:body finish:finish];
      break;
    default:
      break;
  }
}
+ (void)payAlipayCN:(NSString*)url userKey:(NSString*)userKey signKey:(NSString*)signKey outTradeNo:(NSString*)outTradeNo price:(double)price currency:(NSString*)currency subject:(NSString*)subject body:(NSString*)body finish:(void(^_Nullable)(BOOL isError,BOOL isSign,NSDictionary* _Nullable dic))finish{
  
  NSMutableDictionary* dic = [[NSMutableDictionary alloc] init];
  [dic setValue:userKey forKey:@"user_confirm_key"];
  [dic setValue:@"ios" forKey:@"buyerType"];
  [dic setValue:@"Alipay" forKey:@"payType"];
  [dic setValue:@"ALIPAYCN" forKey:@"wallet"];
  [dic setValue:@"123456" forKey:@"tid"];
  //  [dic setValue:@"" forKey:@"notify_url"];
  [dic setValue:outTradeNo forKey:@"out_trade_no"]; //
  [dic setValue:subject forKey:@"subject"];
  [dic setValue:@"APP" forKey:@"pay_scene"];
  [dic setValue:[NSString stringWithFormat:@"%.2f",price] forKey:@"transaction_amount"];
  [dic setValue:body forKey:@"body"];
  
  [dic setValue:[NSDate getDateStringOfFormat:timeForRequest] forKey:@"time"];
  [dic setValue:currency forKey:@"fee_type"];
  
  NSString* sign = [[dic getSign:signKey] SHA256];
  [dic setValue:sign forKey:@"sign"];
  
  [NetWorkServer postWithURL:url params:dic callBack:^(NSError* error, NSString*  data){
    BOOL isError = YES;
    BOOL isSign = NO;
    NSDictionary* resultDic = [NSJSONSerialization getJsonDictionaryWith:data];
    if(resultDic){
      if([@"00" isEqualToString:[resultDic objectForKey:@"return_status"]]){
        isError = NO;
        isSign = [resultDic isSign:signKey];
      }
    }
    if(finish){
      finish(isError,isSign,resultDic);
    }
  }];
}
+ (void)payAlipayHK:(NSString*)url userKey:(NSString*)userKey signKey:(NSString*)signKey outTradeNo:(NSString*)outTradeNo price:(double)price currency:(NSString*)currency subject:(NSString*)subject body:(NSString*)body finish:(void(^_Nullable)(BOOL isError,BOOL isSign,NSDictionary* _Nullable dic))finish{
  
  NSMutableDictionary* dic = [[NSMutableDictionary alloc] init];
  [dic setValue:userKey forKey:@"user_confirm_key"];
  [dic setValue:@"ios" forKey:@"buyerType"];
  [dic setValue:@"Alipay" forKey:@"payType"];
  [dic setValue:@"ALIPAYHK" forKey:@"wallet"];
  [dic setValue:@"123456" forKey:@"tid"];
  //  [dic setValue:@"" forKey:@"notify_url"];
  [dic setValue:outTradeNo forKey:@"out_trade_no"]; //
  [dic setValue:subject forKey:@"subject"];
  [dic setValue:@"APP" forKey:@"pay_scene"];
  [dic setValue:[NSString stringWithFormat:@"%.2f",price] forKey:@"transaction_amount"];
  [dic setValue:body forKey:@"body"];
  
  [dic setValue:[NSDate getDateStringOfFormat:timeForRequest] forKey:@"time"];
  [dic setValue:currency forKey:@"fee_type"];
  NSString* sign = [[dic getSign:signKey] SHA256];
  [dic setValue:sign forKey:@"sign"];
  
  [NetWorkServer postWithURL:url params:dic callBack:^(NSError* error, NSString*  data){
    BOOL isError = YES;
    BOOL isSign = NO;
    NSDictionary* resultDic = [NSJSONSerialization getJsonDictionaryWith:data];
    if(resultDic){
      if([@"00" isEqualToString:[resultDic objectForKey:@"return_status"]]){
        isError = NO;
        isSign = [resultDic isSign:signKey];
      }
    }
    if(finish){
      finish(isError,isSign,resultDic);
    }
  }];
}

+ (void)payWechatHK:(NSString*)url userKey:(NSString*)userKey signKey:(NSString*)signKey outTradeNo:(NSString*)outTradeNo price:(double)price currency:(NSString*)currency subject:(NSString*)subject body:(NSString*)body finish:(void(^_Nullable)(BOOL isError,BOOL isSign,NSDictionary* _Nullable dic))finish {
  
  NSMutableDictionary* dic = [[NSMutableDictionary alloc] init];
  [dic setValue:userKey forKey:@"user_confirm_key"];
  [dic setValue:@"ios" forKey:@"buyerType"];
  [dic setValue:@"WeChat" forKey:@"payType"];
  [dic setValue:@"WECHATHK" forKey:@"wallet"];
  [dic setValue:@"123456" forKey:@"tid"];
  //  [dic setValue:@"" forKey:@"notify_url"];
  [dic setValue:outTradeNo forKey:@"out_trade_no"]; //
  [dic setValue:subject forKey:@"subject"];
  [dic setValue:@"APP" forKey:@"pay_scene"];
  [dic setValue:[NSString stringWithFormat:@"%.2f",price] forKey:@"transaction_amount"];
  [dic setValue:body forKey:@"body"];
  
  [dic setValue:[NSDate getDateStringOfFormat:timeForRequest] forKey:@"time"];
  [dic setValue:currency forKey:@"fee_type"];
  NSString* sign = [[dic getSign:signKey] SHA256];
  [dic setValue:sign forKey:@"sign"];
  [NetWorkServer postWithURL:url params:dic callBack:^(NSError* error, NSString*  data){
    BOOL isError = YES;
    BOOL isSign = NO;
    NSDictionary* resultDic = [NSJSONSerialization getJsonDictionaryWith:data];
    if(resultDic){
      if([@"00" isEqualToString:[resultDic objectForKey:@"return_status"]]){
        isError = NO;
        isSign = [resultDic isSign:signKey str:data];
      }
    }
    if(finish){
      finish(isError,isSign,resultDic);
    }
    
  }];
  
}
+ (void)payWechatCN:(NSString*)url userKey:(NSString*)userKey signKey:(NSString*)signKey outTradeNo:(NSString*)outTradeNo price:(double)price currency:(NSString*)currency subject:(NSString*)subject body:(NSString*)body finish:(void(^_Nullable)(BOOL isError,BOOL isSign,NSDictionary* _Nullable dic))finish {
  
  NSMutableDictionary* dic = [[NSMutableDictionary alloc] init];
  [dic setValue:userKey forKey:@"user_confirm_key"];
  [dic setValue:@"ios" forKey:@"buyerType"];
  [dic setValue:@"WeChat" forKey:@"payType"];
  [dic setValue:@"WECHATCN" forKey:@"wallet"];
  [dic setValue:@"123456" forKey:@"tid"];
  //  [dic setValue:@"" forKey:@"notify_url"];
  [dic setValue:outTradeNo forKey:@"out_trade_no"]; //
  [dic setValue:subject forKey:@"subject"];
  [dic setValue:@"APP" forKey:@"pay_scene"];
  [dic setValue:[NSString stringWithFormat:@"%.2f",price] forKey:@"transaction_amount"];
  [dic setValue:body forKey:@"body"];
  
  [dic setValue:[NSDate getDateStringOfFormat:timeForRequest] forKey:@"time"];
  [dic setValue:currency forKey:@"fee_type"];
  NSString* sign = [[dic getSign:signKey] SHA256];
  [dic setValue:sign forKey:@"sign"];
  [NetWorkServer postWithURL:url params:dic callBack:^(NSError* error, NSString*  data){
    BOOL isError = YES;
    BOOL isSign = NO;
    NSDictionary* resultDic = [NSJSONSerialization getJsonDictionaryWith:data];
    if(resultDic){
      if([@"00" isEqualToString:[resultDic objectForKey:@"return_status"]]){
        isError = NO;
        isSign = [resultDic isSign:signKey str:data];
      }
    }
    if(finish){
      finish(isError,isSign,resultDic);
    }
    
  }];
}


+(void)query:(NSString*)wallet url:(NSString*)url userKey:(NSString*)userKey signKey:(NSString*)signKey outTradeNo:(NSString*)outTradeNo finish:(void(^_Nullable)(BOOL isError,BOOL isSign,NSDictionary* _Nullable dic))finish {
  NSLog(@"query");
  NSString* payTypeStr = @"";
  if([wallet containsString:@"ALIPAY"]){
    payTypeStr = @"Alipay";
  }else if([wallet containsString:@"WECHAT"]){
    payTypeStr = @"WeChat";
  }
 
  NSMutableDictionary* dic = [[NSMutableDictionary alloc] init];
  [dic setValue:@"OUT_TRADE" forKey:@"querytype"];
  [dic setValue:outTradeNo forKey:@"out_trade_no"];
  [dic setValue:userKey forKey:@"user_confirm_key"];
  [dic setValue:payTypeStr forKey:@"paytype"];
  [dic setValue:@"ios" forKey:@"buyertype"];
  [dic setValue:[NSDate getDateStringOfFormat:timeForRequest] forKey:@"time"];
  [dic setValue:wallet forKey:@"payment_type"];
  
  NSString* sign = [[dic getSign:signKey] SHA256];
  [dic setValue:sign forKey:@"sign"];
  [NetWorkServer postWithURL:url params:dic callBack:^(NSError* error, NSString*  data){
    BOOL isError = YES;
    BOOL isSign = NO;
    NSDictionary* resultDic = [NSJSONSerialization getJsonDictionaryWith:data];
    if(resultDic){
      if([@"00" isEqualToString:[resultDic objectForKey:@"return_status"]]){
        isError = NO;
        isSign = [resultDic isSign:signKey];
        NSLog(@"query is sign %d",isSign);
        if(isSign){
          
        }else{
          //自定义签名错误展示
          NSLog(@"query 签名错误");
        }
      }else{
        //自定义错误提示
        NSLog(@"query错误代码:%@,错误描述:%@",[resultDic objectForKey:@"return_status"],[resultDic objectForKey:@"return_char"]);
      }
    }
    if(finish){
      finish(isError,isSign,resultDic);
    }
  }];
}
+(void)query:(NSMutableDictionary*)requestDic finish:(void(^_Nullable)(BOOL isError,BOOL isSign,NSDictionary* _Nullable dic))finish {
  NSLog(@"query");
  
  
  [requestDic setValue:@"OUT_TRADE" forKey:@"querytype"];
  [requestDic setValue:@"ios" forKey:@"buyertype"];
  [requestDic setValue:[NSDate getDateStringOfFormat:timeForRequest] forKey:@"time"];
  NSString* secret_key = [requestDic objectForKey:@"secret_key"];
  [requestDic removeObjectForKey:@"secret_key"];
  NSString* host = [requestDic objectForKey:@"host"];
  [requestDic removeObjectForKey:@"host"];
  NSString* sign = [[requestDic getSign:secret_key] SHA256];
  [requestDic setValue:sign forKey:@"sign"];
  
  [NetWorkServer postWithURL:host params:requestDic callBack:^(NSError* error, NSString*  data){
    BOOL isError = YES;
    BOOL isSign = NO;
    NSDictionary* resultDic = [NSJSONSerialization getJsonDictionaryWith:data];
    if(resultDic){
      if([@"00" isEqualToString:[resultDic objectForKey:@"return_status"]]){
        isError = NO;
        isSign = [resultDic isSign:secret_key];
        NSLog(@"query is sign %d",isSign);
        if(isSign){
          
        }else{
          //自定义签名错误展示
          NSLog(@"query 签名错误");
        }
      }else{
        //自定义错误提示
        NSLog(@"query错误代码:%@,错误描述:%@",[resultDic objectForKey:@"return_status"],[resultDic objectForKey:@"return_char"]);
      }
    }
    if(finish){
      finish(isError,isSign,resultDic);
    }
  }];
}
@end
