#import "EftPaypluginPlugin.h"
#import "EFTPaySDK/PayUtil.h"
#import "EFTPaySDK/NSJSONSerialization+Json.h"



EftPaypluginPlugin* instance;
@implementation EftPaypluginPlugin{
  FlutterResult back;
}
-(void)resultBack:(NSString*)status des:(NSString*)des{
  if(back){
    NSMutableDictionary* dic = [[NSMutableDictionary alloc]init];
    [dic setObject:status forKey:@"return_status"];
    [dic setObject:des forKey:@"des"];
    back(dic);
  }
}
-(void)resultBack:(NSDictionary*)dic{
  if(back){
    back(dic);
  }
}
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"eft_payplugin"
            binaryMessenger:[registrar messenger]];
  instance = [[EftPaypluginPlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
  
}
+(EftPaypluginPlugin*)getInstance{
  return instance;
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  back = result;
  if ([@"getPlatformVersion" isEqualToString:call.method]) {
    result([@"iOS " stringByAppendingString:[[UIDevice currentDevice] systemVersion]]);
  }else if([@"request_deviceid_permission" isEqualToString:call.method]){
    result(@"00");
  }else if([@"regiest" isEqualToString:call.method]){
    //向微信注册,发起支付必须注册
    BOOL r = [WXApi registerApp: (NSString*)[call.arguments objectForKey:@"appid"] universalLink:(NSString*)[call.arguments objectForKey:@"universalLink"]];
    result(r?@"00":@"01");
  }else if ([@"pay" isEqualToString:call.method]) {
    NSLog(@"%@",[call.arguments allKeys]);
    NSMutableDictionary* dic = [[NSMutableDictionary alloc] init];
    [dic setDictionary:call.arguments];
    [self eftpay:dic];
  }else if([@"query" isEqualToString:call.method]){
    NSLog(@"%@",call.arguments);
    NSMutableDictionary* dic = [[NSMutableDictionary alloc] init];
    [dic setDictionary:call.arguments];
    [self query:dic];
  }else {
    result(FlutterMethodNotImplemented);
  }
}
- (void)eftpay:(NSMutableDictionary*)requestDic {
  NSString* wallet = [requestDic objectForKey:@"wallet"];
  //调起支付
  [PayUtil pay:requestDic finish:^(BOOL isError, BOOL isSign, NSDictionary * _Nullable dic) {
    if(dic){
      if(isError){
        //处理错误提示
        NSLog(@"错误代码:%@,错误描述:%@",[dic objectForKey:@"return_status"],[dic objectForKey:@"return_char"]);
        [self resultBack:[dic objectForKey:@"return_status"] des:[dic objectForKey:@"return_char"]];
      }else {
        if(isSign){
          if([@"ALIPAYCN" isEqualToString:wallet]||[@"ALIPAYHK" isEqualToString:wallet]){
            //正常下单
            NSLog(@"Test Alipay正常下单");
            //只有签名正确才调起支付
            NSString* payString = [dic objectForKey:@"pay_apptrade"];
            //调起支付宝支付
            [[AlipaySDK defaultService] payOrder:payString fromScheme:@"eftpayltxgtpay" callback:^(NSDictionary *resultDic) {
              //当没有安装支付宝APP时,调起Web支付后的回调
              NSLog(@"payAlipay reslut = %@",resultDic);
              [self dealAlipayDic:resultDic];
            }];
          }else if([@"WECHATCN" isEqualToString:wallet]){
            //正常下单
            NSLog(@"Test WechatCN正常下单");
            //只有签名正确才调起支付
            NSDictionary* dict = [dic objectForKey:@"pay_apptrade"];
            //调起微信支付
            PayReq* req             = [[PayReq alloc] init];
            req.partnerId           = [dict objectForKey:@"partnerid"];
            req.prepayId            = [dict objectForKey:@"prepayid"];
            req.nonceStr            = [dict objectForKey:@"noncestr"];
            req.timeStamp           = [[dict objectForKey:@"timestamp"]intValue];
            req.package             = [dict objectForKey:@"package"];
            req.sign                = [dict objectForKey:@"sign"];

            
            [WXApi sendReq:req completion:^(BOOL success) {
              
            }];
          }else{
            [self resultBack:@"-2" des:@"参数异常"];
          }
          
          
        }else{
          //自定义签名错误展示
          NSLog(@"签名错误");
          [self resultBack:@"-10" des:@"签名错误"];
        }
      }
    }else{
      //网络错误
      [self resultBack:@"-4" des:@"网络错误"];
    }
  }];
}

-(void)dealAlipayDic:(NSDictionary*)resultDic{
  if(resultDic){
    NSString* resultStatus = [resultDic objectForKey:@"resultStatus"];
    NSString* memo = [resultDic objectForKey:@"memo"];
    if([@"9000" isEqualToString:resultStatus]){
      //展示支付成功
      [self resultBack:@"9000" des:@"支付成功"];
      return;
    }
    //状态结果,如下状态必须查询后再做处理
    else if([@"8000" isEqualToString:resultStatus]||[@"6004" isEqualToString:resultStatus]){
      [self resultBack:resultStatus des:memo];
    }else {
      [self resultBack:resultStatus des:memo];
    }
  }
}




- (BOOL)application:(UIApplication *)application
            openURL:(NSURL *)url
  sourceApplication:(NSString *)sourceApplication
         annotation:(id)annotation {
  NSLog(@"openURL=%@",url);
  if ([url.host isEqualToString:@"safepay"]) {
    //跳转支付宝钱包进行支付，处理支付结果
    [[AlipaySDK defaultService] processOrderWithPaymentResult:url standbyCallback:^(NSDictionary *resultDic) {
      NSLog(@"AppDelegate result = %@",resultDic);
      [self dealAlipayDic:resultDic];
    }];
  }else if ([url.host isEqualToString:@"pay"]){
    [WXApi handleOpenURL:url delegate:self];
  }
  return YES;
}

// NOTE: 9.0以后使用新API接口
- (BOOL)application:(UIApplication *)app openURL:(NSURL *)url options:(NSDictionary<NSString*, id> *)options
{
  NSLog(@"openURL=%@",url);
  if ([url.host isEqualToString:@"safepay"]) {
    //当安装了支付宝APP时,调起支付后的回调
    //跳转支付宝钱包进行支付，处理支付结果
    [[AlipaySDK defaultService] processOrderWithPaymentResult:url standbyCallback:^(NSDictionary *resultDic) {
      NSLog(@"AppDelegate result = %@",resultDic);
      [self dealAlipayDic:resultDic];
    }];
    
  }else if ([url.host isEqualToString:@"pay"]){
    //跳转处理微信支付返回结果
    [WXApi handleOpenURL:url delegate:self];
  }
  return YES;
}


- (BOOL)application:(UIApplication *)application handleOpenURL:(NSURL *)url {
  return  [WXApi handleOpenURL:url delegate:self];
}

#pragma mark - WXApiDelegate
- (void)onResp:(BaseResp *)resp {
  if([resp isKindOfClass:[PayResp class]]){
    NSString* strMsg = @"";
    //处理微信支付返回结果
    switch (resp.errCode) {
      case WXSuccess:
        strMsg = @"支付结果：成功！";
        NSLog(@"支付成功－PaySuccess，retcode = %d", resp.errCode);
         [self resultBack:@"0" des:@"支付成功"];
        break;
        
      default:
        strMsg = [NSString stringWithFormat:@"支付结果：失败！retcode = %d, retstr = %@", resp.errCode,resp.errStr];
        NSLog(@"错误，retcode = %d, retstr = %@", resp.errCode,resp.errStr);
        [self resultBack:[NSString stringWithFormat:@"%d",resp.errCode] des:[NSString stringWithFormat:@"%@",resp.errStr]];
        break;
    }
  }
}

- (void)query:(NSMutableDictionary*)requestDic{
//  [PayUtil query:[requestDic objectForKey:@"wallet"]
//             url:[requestDic objectForKey:@"host"]
//         userKey:[requestDic objectForKey:@"user_confirm_key"]
//         signKey:[requestDic objectForKey:@"secret_key"]
//      outTradeNo:[requestDic objectForKey:@"out_trade_no"] finish:^(BOOL isError, BOOL isSign, NSDictionary * _Nullable dic) {
  [PayUtil query:requestDic finish:^(BOOL isError, BOOL isSign, NSDictionary * _Nullable dic) {
    if(dic){
      if(isError){
        //处理错误提示
        NSLog(@"query错误代码:%@,错误描述:%@",[dic objectForKey:@"return_status"],[dic objectForKey:@"return_char"]);
        [self resultBack:dic];
      }else {
        if(isSign){
          //查询正常
          NSLog(@"query正常返回查询结果");
          [self resultBack:dic];
          
        }else{
          //自定义签名错误展示
          NSLog(@"query签名错误");
          [self resultBack:@"-10" des:@"签名错误"];
        }
      }
    }else{
      //网络错误
      [self resultBack:@"-4" des:@"网络错误"];
    }
  }];
}


@end
